Package org.codehaus.groovy.vmplugin.v7

# Class IndyInterface

java.lang.Object
org.codehaus.groovy.vmplugin.v7.IndyInterface

    @Deprecated
    public class IndyInterface
    extends java.lang.Object

Deprecated.
Legacy class containing methods called by Groovy 2.5 Indy compiled bytecode. Includes the interfacing methods with bytecode for invokedynamic and some helper methods and classes.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type | Class | Description
  --- | --- | ---
  `static class` | `IndyInterface.CallType` | Deprecated. Enum for easy differentiation between call types.

- ## Field Summary

  Fields
  Modifier and Type | Field | Description
  --- | --- | ---
  `static int` | `GROOVY_OBJECT` | Deprecated. Flags for method and property calls.
  `static int` | `IMPLICIT_THIS` | Deprecated. Flags for method and property calls.
  `protected static java.util.logging.Logger` | `LOG` | Deprecated.
  `protected static boolean` | `LOG_ENABLED` | Deprecated.
  `static java.lang.invoke.MethodHandles.Lookup` | `LOOKUP` | Deprecated. LOOKUP constant used for example in unreflect calls.
  `static int` | `SAFE_NAVIGATION` | Deprecated. Flags for method and property calls.
  `static int` | `SPREAD_CALL` | Deprecated. Flags for method and property calls.
  `protected static java.lang.invoke.SwitchPoint` | `switchPoint` | Deprecated.
  `static int` | `THIS_CALL` | Deprecated. Flags for method and property calls.
  `static int` | `UNCACHED_CALL` | Deprecated. Flags for method and property calls.

- ## Constructor Summary

  Constructors
  Constructor | Description
  --- | ---
  `IndyInterface()` | Deprecated.

- ## Method Summary

  Modifier and Type | Method | Description
  --- | --- | ---
  `static java.lang.invoke.CallSite` | `bootstrap​(java.lang.invoke.MethodHandles.Lookup caller, java.lang.String callType, java.lang.invoke.MethodType type, java.lang.String name, int flags)` | Deprecated. Bootstrap method for method calls from Groovy compiled code with indy enabled.
  `static java.lang.Object` | `fromCache​(java.lang.invoke.MutableCallSite callSite, java.lang.Class<?> sender, java.lang.String methodName, int callID, java.lang.Boolean safeNavigation, java.lang.Boolean thisCall, java.lang.Boolean spreadCall, java.lang.Object dummyReceiver, java.lang.Object[] arguments)` | Deprecated. Get the cached methodhandle.
  `protected static void` | `invalidateSwitchPoints()` | Deprecated. Callback for constant meta class update change.
  `static java.lang.Object` | `selectMethod​(java.lang.invoke.MutableCallSite callSite, java.lang.Class<?> sender, java.lang.String methodName, int callID, java.lang.Boolean safeNavigation, java.lang.Boolean thisCall, java.lang.Boolean spreadCall, java.lang.Object dummyReceiver, java.lang.Object[] arguments)` | Deprecated. Core method for indy method selection using runtime types.
  `static java.lang.invoke.CallSite` | `staticArrayAccess​(java.lang.invoke.MethodHandles.Lookup lookup, java.lang.String name, java.lang.invoke.MethodType type)` | Deprecated.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### SAFE_NAVIGATION

    public static final int SAFE_NAVIGATION
    Deprecated.
    Flags for method and property calls.
    See Also:
      Constant Field Values

  - ### THIS_CALL

    public static final int THIS_CALL
    Deprecated.
    Flags for method and property calls.
    See Also:
      Constant Field Values

  - ### GROOVY_OBJECT

    public static final int GROOVY_OBJECT
    Deprecated.
    Flags for method and property calls.
    See Also:
      Constant Field Values

  - ### IMPLICIT_THIS

    public static final int IMPLICIT_THIS
    Deprecated.
    Flags for method and property calls.
    See Also:
      Constant Field Values

  - ### SPREAD_CALL

    public static final int SPREAD_CALL
    Deprecated.
    Flags for method and property calls.
    See Also:
      Constant Field Values

  - ### UNCACHED_CALL

    public static final int UNCACHED_CALL
    Deprecated.
    Flags for method and property calls.
    See Also:
      Constant Field Values

  - ### LOG

    protected static java.util.logging.Logger LOG
    Deprecated.

  - ### LOG_ENABLED

    protected static final boolean LOG_ENABLED
    Deprecated.

  - ### LOOKUP

    public static final java.lang.invoke.MethodHandles.Lookup LOOKUP
    Deprecated.
    LOOKUP constant used for example in unreflect calls.

  - ### switchPoint

    protected static java.lang.invoke.SwitchPoint switchPoint
    Deprecated.

- ## Constructor Details

  - ### IndyInterface

    public IndyInterface()
    Deprecated.

- ## Method Details

  - ### invalidateSwitchPoints

    protected static void invalidateSwitchPoints()
    Deprecated.
    Callback for constant meta class update change.

  - ### bootstrap

    public static java.lang.invoke.CallSite bootstrap​(java.lang.invoke.MethodHandles.Lookup caller, java.lang.String callType, java.lang.invoke.MethodType type, java.lang.String name, int flags)
    Deprecated.
    Bootstrap method for method calls from Groovy compiled code with indy enabled. This method gets a flags parameter which uses the following encoding:
    - 1 is the flag value for safe navigation see `SAFE_NAVIGATION`
    - 2 is the flag value for a call on this see `THIS_CALL`
    Parameters:
      `caller` - - the caller
      `callType` - - the type of the call
      `type` - - the call site type
      `name` - - the real method name
      `flags` - - call flags
    Returns:
      the produced CallSite
    Since:
      2.1.0

  - ### fromCache

    public static java.lang.Object fromCache​(java.lang.invoke.MutableCallSite callSite, java.lang.Class<?> sender, java.lang.String methodName, int callID, java.lang.Boolean safeNavigation, java.lang.Boolean thisCall, java.lang.Boolean spreadCall, java.lang.Object dummyReceiver, java.lang.Object[] arguments) throws java.lang.Throwable
    Deprecated.
    Get the cached methodhandle. if the related methodhandle is not found in the inline cache, cache and return it.
    Throws:
      `java.lang.Throwable`

  - ### selectMethod

    public static java.lang.Object selectMethod​(java.lang.invoke.MutableCallSite callSite, java.lang.Class<?> sender, java.lang.String methodName, int callID, java.lang.Boolean safeNavigation, java.lang.Boolean thisCall, java.lang.Boolean spreadCall, java.lang.Object dummyReceiver, java.lang.Object[] arguments) throws java.lang.Throwable
    Deprecated.
    Core method for indy method selection using runtime types.
    Throws:
      `java.lang.Throwable`

  - ### staticArrayAccess

    public static java.lang.invoke.CallSite staticArrayAccess​(java.lang.invoke.MethodHandles.Lookup lookup, java.lang.String name, java.lang.invoke.MethodType type)
    Deprecated.
    Since:
      2.5.0